//--------LICENSE_START--------
//
// Copyright (C) 2020,2021,2022 Institut de Robòtica i Informàtica Industrial, CSIC-UPC.
// Authors: Joan Solà Ortega (jsola@iri.upc.edu)
// All rights reserved.
//
// This file is part of WOLF
// WOLF is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//--------LICENSE_END--------
#include "bodydynamics/capture/capture_force_torque_inertial.h"

#include <core/state_block/state_block_derived.h>

namespace wolf
{
CaptureForceTorqueInertial::CaptureForceTorqueInertial(const TimeStamp&       _init_ts,
                                                       SensorBasePtr          _sensor_ptr,
                                                       const Eigen::VectorXd& _data,
                                                       const Eigen::MatrixXd& _data_cov,
                                                       CaptureBasePtr         _capture_origin_ptr)
    : CaptureMotion("CaptureForceTorqueInertial",
                    _init_ts,
                    _sensor_ptr,
                    _data,
                    _data_cov,
                    _capture_origin_ptr,
                    nullptr,                                // position is static
                    nullptr,                                // orientation is static
                    (_sensor_ptr->isStateBlockDynamic('I')  // dynamic intrinsics are IMU bias
                         ? std::make_shared<StateParams6>(_sensor_ptr->getStateBlockDynamic('I')->getState(), false)
                         : nullptr))
{
    //
}

CaptureForceTorqueInertial::~CaptureForceTorqueInertial() {}

}  // namespace wolf